/*
 * reimplementation of Daniel Bernstein's unix library.
 * placed in the public domain by Uwe Ohse, uwe@ohse.de.
 */
#include "divedata.h"
#include "gen_alloci.h"
#include "bailout.h"

int
dralloc_append(dralloc *s, struct diverecord *r)
{
  return gen_alloc_append((char **)&s->ix,sizeof(*r), &s->len, &s->a, (char *)r);
}
void
reinit_dive(struct dive *d, const char *id)
{
  if (!stralloc_copys(&d->id0,id)) oom();
  if (!stralloc_0(&d->id0)) oom();
  d->data.len=0;
  strhash_destroy(&d->h_config);
  strhash_destroy(&d->h_dive);
  if (-1==strhash_create(&d->h_config,1,32,strhash_hash)) oom();
  if (-1==strhash_create(&d->h_dive,1,32,strhash_hash)) oom();
  d->maxdepth=0;
  d->totalseconds=0;
}
