#ifndef DIVEDATA_H
#define DIVEDATA_H

#define FOOT 0.3048
#include "strhash.h"
#include "stralloc.h"
#include "tai.h"

#define DDF_SLOW                   0x01
#define DDF_ATTENTION              0x02
#define DDF_BOOKMARK               0x04
#define DDF_SURFACED               0x08
#define DDF_DECO_STOP_NEEDED       0x10
#define DDF_DECO_STOP_VIOLATION    0x20
#define DDF_SAFETY_STOP_VIOLATION  0x40
#define DDF_UNKNOWN                0x80
#define DDF_SWITCH                0x100 /* gas switch */

struct diverecord {
  unsigned int  endtime;
  unsigned long depth;
  unsigned long flags;
  unsigned short o2_percentage; /* only useful when flags&DDF_SWITCH */
};

#include "gen_alloc.h"
GEN_ALLOC_typedef(dralloc,struct diverecord,ix,len,a)
extern int dralloc_append(dralloc *,struct diverecord *);
extern void dralloc_free(dralloc *);

struct dive {
  stralloc id0;
  dralloc data;
  unsigned long totalseconds;
  unsigned long maxdepth; /* cm */
  unsigned long avgdepth; /* cm */
  strhash h_config;
  strhash h_dive;
  struct tai start_time;
};
extern void reinit_dive(struct dive *, const char *id);

const char * gv(strhash *h, const char *s);

#endif
