#include "scan__float.h"
#include "uogetopt.h"
#include "mosquitotools.h"
#include "str.h"
static void warn_no_length(uogetopt_env *e, char *s)
{
  e->out(e,e->program);
  e->out(e,": cannot parse length: ");
  e->out(e,s);
  e->out(e,"\n");
}
int
do_length_opt(uogetopt_env *e, uogetopt2 *o,char *s)
{
  unsigned int l;
  float x;
  l=scan__float(s,&x);
  if (!l) {
    warn_no_length(e,s);
    return 1;
  }
  if (s[l]) {
    if (str_equal(s+l,"m")) {
      /* nothing */
    } else if (str_equal(s+l,"meter")) {
      /* nothing */
    } else if (str_equal(s+l,"cm")) {
      x/=100;
    } else if (str_equal(s+l,"mm")) {
      x/=1000;
    } else if (str_equal(s+l,"f")) {
      x*=FOOT;
    } else if (str_equal(s+l,"foot")) {
      x*=FOOT;
    } else if (str_equal(s+l,"feet")) {
      x*=FOOT;
    } else if (str_equal(s+l,"yard")) {
      x*=0.9144;
    } else {
      warn_no_length(e,s);
      return 1;
    }
  }
  *(float *)o->var=x;
  return 0;
}
