#include "scan__float.h"
#include "uogetopt.h"
#include "mosquitotools.h"
#include "str.h"
static void warn_no_pressure(uogetopt_env *e, char *s)
{
  e->out(e,e->program);
  e->out(e,": cannot parse pressure: ");
  e->out(e,s);
  e->out(e,"\n");
}
int
do_pressure_opt(uogetopt_env *e, uogetopt2 *o,char *s)
{
  unsigned int l;
  float x;
  l=scan__float(s,&x);
  if (!l) {
    warn_no_pressure(e,s);
    return 1;
  }
  if (s[l]) {
    if (str_equal(s+l,"bar")) {
      /* nothing */
    } else if (str_equal(s+l,"mbar")) {
      x/=1000;
    } else if (str_equal(s+l,"psi")) {
      x*=0.0689476;
    } else if (str_equal(s+l,"hpa")) {
      x*=0.001;
    } else if (str_equal(s+l,"kpa")) {
      x*=0.01;
    } else if (str_equal(s+l,"atm")) {
      x*=1.0132502;
    } else {
      warn_no_pressure(e,s);
      return 1;
    }
  }
  *(float *)o->var=x;
  return 0;
}
