#include "scan.h"
#include "uogetopt.h"
#include "mosquitotools.h"
#include "str.h"
static void warn_no_time(uogetopt_env *e, char *s)
{
  e->out(e,e->program);
  e->out(e,": cannot parse time: ");
  e->out(e,s);
  e->out(e,"\n");
}
int
do_timelength_opt(uogetopt_env *e, uogetopt2 *o,char *s)
{
  unsigned int l;
  unsigned long x;
  l=scan_ulong(s,&x);
  if (!l) {
    warn_no_time(e,s);
    return 1;
  }
  if (s[l]) {
    if (str_start(s+l,"s")) { /* second */
      /* nothing */
    } else if (str_start(s+l,"m")) { /* min */
      x*=60;
    } else if (str_start(s+l,"h")) { /* hour */
      x*=3600;
    } else if (str_start(s+l,"d")) { /* days */
      x*=86400;
    } else {
      warn_no_time(e,s);
      return 1;
    }
  }
  *(unsigned long *)o->var=x;
  return 0;
}
