#include "divedata.h"
#include "mosquitotools.h"
#include "open.h"
#include "error.h"
#include "bailout.h"
#include "close.h"
#include "readwrite.h"
#include "byte.h"

static stralloc sa;
static unsigned int sa_got;
static void do_buffer(void)
{
  char b[1024];
  while (1) {
    int x;
    x=read(0,b,sizeof(b));
    if (-1==x) {
      if (errno==error_intr)
	continue;
      xbailout(111,errno,"failed to read stdin",0,0,0);
    }
    if (!x)
      break;
    if (!stralloc_catb(&sa,b,x)) oom();
  }
}

static int 
my_buf_read(int dummy, char *to, unsigned int l)
{
  (void) dummy;
  if (l+sa_got>sa.len)
    l=sa.len-sa_got;
  byte_copy(to,l,sa.s+sa_got);
  sa_got+=l;
  return l;
}

void
format_handler(const char *fn, void (*callback)(struct dive *))
{
  int fd;
  buffer b; 
  char bspace[BUFFER_INSIZE];

  if (fn[0]=='-' && !fn[1]) {
    static int buffered;
    if (!buffered) {
      buffered=1;
      do_buffer();
    }
    fd=0;
    sa_got=0;
    buffer_init(&b,(buffer_op_t) my_buf_read, 0, bspace,sizeof(bspace));
  }
  else {
    fd=open_read(fn);
    if (-1==fd)
      xbailout(111,errno,"failed to open ",fn,0,0);
    buffer_init(&b,(buffer_op_t) read, fd, bspace,sizeof(bspace));
  }
  
  handle_mosquitoget(&b,callback);
  if (fd)
    close(fd);
}
