#include "bailout.h"
#include "buffer.h"
#include "errno.h"
#include "str.h"
#include "fmt.h"
#include "out.h"

static buffer *ob;

void out_set_buffer(buffer *b) { ob=b; }

void
outb(const char *s, unsigned long l)
{
  if (!ob) ob=buffer_1;
  if (-1==buffer_put(ob,s,l)) 
    xbailout(111,errno,"failed to write",0,0,0);
}
void outs(const char *s) { outb(s,str_len(s)); }
void outu(unsigned long u)
{
  char nb[FMT_ULONG];
  outb(nb,fmt_ulong(nb,u));
}
void outu0(unsigned long u, unsigned int l)
{
  char nb[FMT_ULONG];
  outb(nb,fmt_ulong0(nb,u,l));
}
void outun(unsigned long u, unsigned int l)
{
  char nb[FMT_ULONG];
  unsigned int x;
  x=fmt_ulong(nb,u);
  if (x<l) {
    l-=x;
    while (l--) 
      outb(" ",1);
  }
  outb(nb,x);
}
void
outflush(void)
{
  if (!ob) ob=buffer_1;
  if (-1==buffer_flush(ob)) 
    xbailout(111,errno,"failed to write",0,0,0);
}
void 
outf(float f,unsigned long l)
{
  char nb[FMT__DOUBLE];
  outb(nb,fmt__double(nb,f,0,l));
}
void
outx(unsigned long u, unsigned long l)
{
	char nb[FMT_ULONG];
	outb(nb,fmt_xlong0(nb,u,l));
}
