#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#include <termios.h>
#include "rts.h"
#include "msleep.h"

static int
RTS_change(int fd, int on)
{
#if defined(TIOCMBIS) && defined(TIOCMBIC)
  int v=TIOCM_RTS;
  if (ioctl(fd,on ? TIOCMBIS : TIOCMBIC,&v))
    return -1;
#elif defined(TIOCM_RTS) && defined(TIOCMGET) && defined(TIOCMSET)
  int status;
  if (ioctl(fd,TIOCMGET,&status))
    return -1;
  if (on)
    status |= TIOCM_RTS;
  else
    status &= ~TIOCM_RTS;
  if (ioctl(fd,TIOCMSET,&status))
    return -1;

#else
#error "no way to set/clear rts"
#endif

  /* ### sicherheitshalber etwas warten */
  /* note: this sleep was in the TOM BBS from 1990 on or so ... and things
   * still have not changed. */
  msleep(on ? 200 : 500);
  return 0;
}

int RTS_on(int fd) { return RTS_change(fd,1); }
int RTS_off(int fd) { return RTS_change(fd,0); }
