#include "math.h"
#include "scan__double.h"

unsigned int 
scan__double(const char *s,double *f)
{
  double m;
  const char *start=s;
  int vz=1;
  if (*s=='-') {s++; vz=-1;}
  if (*s=='+') {s++;}
  m=0;
  while (1) {
    if (*s>='0' && *s<='9') {
      m*=10;
      m+=*s-'0';
      s++;
    } else 
      break;
  }
  if (*s=='.') {
    unsigned long long ull;
    s++;
    ull=10;
    while (1) {
      if (*s>='0' && *s<='9') {
	m+=(*s-'0')/(double)ull;
	ull*=10;
	s++;
      } else 
	break;
    }
  }
  if ((*s=='e' || *s=='E') && (s[1]=='+' || s[1]=='-' || (s[1]>='0' && s[1]<='9'))) {
    double factor=10;
    unsigned int e=0;
    s++;
    if (*s=='-') {s++; factor=0.1;}
    if (*s=='+') s++;
    while (1) {
      if (*s>='0' && *s<='9') {
	e*=10;
	e+=(*s-'0');
	s++;
      } else 
	break;
    }
    while (e) {
      e--;
      m*=factor;
    }
  }
  m*=vz;
  if (isnan(m) || isinf(m))
    return 0;
  *f=m;
  return s-start;
}
#ifdef TEST
#include <stdio.h>
#define D(x) do { printf("in='%s' -> ",x);l=scan__double(x,&d); \
printf(" l=%u d=%E  (%d,%d)\n",l,d,isnan(d),isinf(d)); } while(0)
int main(void)
{	
  double d;
  unsigned int l;
  D("X");
  D("0");
  D("-0");
  D("1");
  D("-1");
  D("1234");
  D("-1234");
  D("1234.56");
  D("-1234.56");
  D("1234.56e1");
  D("1234.56e-1");
  D("1234.56e10");
  D("1234.56e-10");
  D("1234.56ex-10");
  D("1234.56e4");
  D("1234.56e40");
  D("1234.56e400");
  return 0;
}
#endif
