#include "math.h"
#include "scan__float.h"
#include "scan__double.h"

unsigned int 
scan__float(const char *s,float *f)
{
  double d;
  float e;
  unsigned int l;
  l=scan__double(s,&d);
  if (!l) return 0;
  e=d;
  if (isnan(e) || isinf(e))
    return 0;
  *f=e;
  return l;
}
#ifdef TESTF
#include <stdio.h>
#define D(x) do { d=42; printf("in='%s' -> ",x);l=scan__float(x,&d); \
printf(" l=%u d=%E  (%d,%d)\n",l,d,isnan(d),isinf(d)); } while(0)
int main(void)
{	
  float d;
  unsigned int l;
  D("X");
  D("0");
  D("-0");
  D("1");
  D("-1");
  D("1234");
  D("-1234");
  D("1234.56");
  D("-1234.56");
  D("1234.56e1");
  D("1234.56e-1");
  D("1234.56e10");
  D("1234.56e-10");
  D("1234.56ex-10");
  D("1234.56e4");
  D("1234.56e40");
  D("1234.56e400");
  return 0;
}
#endif
