/*
 * Copyright (C) 2000-2002 Uwe Ohse, uwe@ohse.de
 * This is free software, licensed under the terms of the GNU Lesser
 * General Public License Version 2.1, of which a copy is stored at:
 *    http://www.ohse.de/uwe/licenses/LGPL-2.1
 * Later versions may or may not apply, see 
 *    http://www.ohse.de/uwe/licenses/
 * for information after a newer version has been published.
 */
#include <stdlib.h> /* malloc */
#include "uogetopt.h"

#define L longname
#define S shortname

static unsigned int 
count(uogetopt2 *opts)
{
	unsigned int c=0;
	unsigned int i;
	for (i=0;opts[i].S || opts[i].L;i++) {
		if (opts[i].function==uogo_include) {
			if (opts[i].var)
				c+=count((uogetopt2 *)opts[i].var);
		} else
			c++;
	}
	return c;
}
static unsigned int
copy(uogetopt2 *out, uogetopt2 *in, int off, int lv)
{
	unsigned int i;
	for (i=0;in[i].S || in[i].L;i++) {
		if (in[i].function==uogo_include) {
			if (in[i].var)
				off=copy(out,(uogetopt2 *)in[i].var,off,lv+1);
		} else 
			out[off++]=in[i];
	}
	if (lv==0)
		out[off]=in[i];
	return off;
}

uogetopt2 *
uogetopt_join(uogetopt2 *opts)
{
	uogetopt2 *o;
	unsigned int n;
	n=count(opts)+1; /* null */
	o=malloc(sizeof(uogetopt2)*n);
	if (!o) return 0;
	copy(o,opts,0,0);
	return o;
}
void
uogetopt_free(uogetopt2 *opts)
{ 	
	free(opts);
}
