#define PWV37 0.0627 /* pressure of water vapor at 37 degrees celsius */
#define PCO2  0.0534 /* pressure of CO2 in the lungs */
#define MAX_NO_DECO_TIME (60*60) /* one hour */

extern float zhl16_sat_factor;
extern float zhl16_desat_factor;

void zhl16_setting(const char *name);
float *zhl16_alloc(unsigned int *gewebe);
void zhl16_copy(float *to,float *from);
void zhl16_free(float *x);
float zhl16_init_load(float *x, float air_pressure, float nixtrox_anteil);
void zhl16_calc_load(float *load, float air_pressure, float nitrox_anteil,
  float depth, unsigned int interval);
void zhl16_get_max_load_for_depth(float *maxloads, 
  float air_pressure, float nitrox_anteil, float depth);
unsigned long zhl16_calc_no_dec_time(float *load, float air_pressure, 
  float nitrox_anteil, float depth);
float zhl16_min_save_depth(float *load, float surface_pressure, 
  float nitrox_anteil);



